module Main where

import Common.Utils

import InternalRepresentation.Tokens
import InternalRepresentation.Values

import SyntaxEngine.Result
import SyntaxEngine.Pos

import Interpreter.Tokenizer
import Interpreter.Parser

import DataStructures.Tree



parse tokenForest = case tokenForest of
	Failure f -> "Tokenization already failed"
	Success tf -> unlines $ map show (fMap parseLine tf)
	where
		parseLine = (map inside) >>> pDefinition




go file = do
	txt <- readFile file
	putStrLn ("File processed: " ++ file)
	putStrLn ""

	putStrLn ("Result of tokenizing:")
	tokenForest <- return (tokenize txt)
	putStrLn (show tokenForest)

	putStrLn ""
	putStrLn "------------------------------------------------------------"
	putStrLn ""

	putStrLn ("Result of parsing:")
	parsedForest <- return (parse tokenForest)
	putStrLn (parsedForest)



main = go "examples/ex1.txt"